Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.xpath
Class XPathAPI

    java.lang.Object
      |
      +--org.apache.xpath.XPathAPI

public class XPathAPI
extends java.lang.Object

The methods in this class are convenience methods into the low-level XPath API. These functions tend to be a little slow, since a number of objects must be created for each evaluation. A faster way is to precompile the XPaths using the low-level API, and then just use the XPaths over and over. NOTE: In particular, each call to this method will create a new XPathContext, a new DTMManager... and thus a new DTM. That's very safe, since it guarantees that you're always processing against a fully up-to-date view of your document. But it's also portentially very expensive, since you're rebuilding the DTM every time. You should consider using an instance of CachedXPathAPI rather than these static methods.

See Also:
  XPath Specification

Constructor Summary
`XPathAPI()`

Method Summary
`static XObject` | `eval(Node contextNode, java.lang.String str)` Evaluate XPath string to an XObject.
`static XObject` | `eval(Node contextNode, java.lang.String str, Node namespaceNode)` Evaluate XPath string to an XObject.
`static XObject` | `eval(Node contextNode, java.lang.String str, PrefixResolver prefixResolver)` Evaluate XPath string to an XObject.
`static NodeIterator` | `selectNodeIterator(Node contextNode, java.lang.String str)` Use an XPath string to select a nodelist.
`static NodeIterator` | `selectNodeIterator(Node contextNode, java.lang.String str, Node namespaceNode)` Use an XPath string to select a nodelist.
`static NodeList` | `selectNodeList(Node contextNode, java.lang.String str)` Use an XPath string to select a nodelist.
`static NodeList` | `selectNodeList(Node contextNode, java.lang.String str, Node namespaceNode)` Use an XPath string to select a nodelist.
`static Node` | `selectSingleNode(Node contextNode, java.lang.String str)` Use an XPath string to select a single node.
`static Node` | `selectSingleNode(Node contextNode, java.lang.String str, Node namespaceNode)` Use an XPath string to select a single node.

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### XPathAPI

    public XPathAPI()

Method Detail

### selectSingleNode

    public static Node selectSingleNode(Node contextNode,
                                        java.lang.String str)
                                 throws TransformerException

  Use an XPath string to select a single node. XPath namespace prefixes are resolved from the context node, which may not be what you want (see the next method).
  Parameters:
    `contextNode` - The node to start searching from.
    `str` - A valid XPath string.
  Returns:
    The first node found that matches the XPath, or null.
  Throws:
    TransformerException -

### selectSingleNode

    public static Node selectSingleNode(Node contextNode,
                                        java.lang.String str,
                                        Node namespaceNode)
                                 throws TransformerException

  Use an XPath string to select a single node. XPath namespace prefixes are resolved from the namespaceNode.
  Parameters:
    `contextNode` - The node to start searching from.
    `str` - A valid XPath string.
    `namespaceNode` - The node from which prefixes in the XPath will be resolved to namespaces.
  Returns:
    The first node found that matches the XPath, or null.
  Throws:
    TransformerException -

### selectNodeIterator

    public static NodeIterator selectNodeIterator(Node contextNode,
                                                  java.lang.String str)
                                           throws TransformerException

  Use an XPath string to select a nodelist. XPath namespace prefixes are resolved from the contextNode.
  Parameters:
    `contextNode` - The node to start searching from.
    `str` - A valid XPath string.
  Returns:
    A NodeIterator, should never be null.
  Throws:
    TransformerException -

### selectNodeIterator

    public static NodeIterator selectNodeIterator(Node contextNode,
                                                  java.lang.String str,
                                                  Node namespaceNode)
                                           throws TransformerException

  Use an XPath string to select a nodelist. XPath namespace prefixes are resolved from the namespaceNode.
  Parameters:
    `contextNode` - The node to start searching from.
    `str` - A valid XPath string.
    `namespaceNode` - The node from which prefixes in the XPath will be resolved to namespaces.
  Returns:
    A NodeIterator, should never be null.
  Throws:
    TransformerException -

### selectNodeList

    public static NodeList selectNodeList(Node contextNode,
                                          java.lang.String str)
                                   throws TransformerException

  Use an XPath string to select a nodelist. XPath namespace prefixes are resolved from the contextNode.
  Parameters:
    `contextNode` - The node to start searching from.
    `str` - A valid XPath string.
  Returns:
    A NodeIterator, should never be null.
  Throws:
    TransformerException -

### selectNodeList

    public static NodeList selectNodeList(Node contextNode,
                                          java.lang.String str,
                                          Node namespaceNode)
                                   throws TransformerException

  Use an XPath string to select a nodelist. XPath namespace prefixes are resolved from the namespaceNode.
  Parameters:
    `contextNode` - The node to start searching from.
    `str` - A valid XPath string.
    `namespaceNode` - The node from which prefixes in the XPath will be resolved to namespaces.
  Returns:
    A NodeIterator, should never be null.
  Throws:
    TransformerException -

### eval

    public static XObject eval(Node contextNode,
                               java.lang.String str)
                        throws TransformerException

  Evaluate XPath string to an XObject. Using this method, XPath namespace prefixes will be resolved from the namespaceNode.
  Parameters:
    `contextNode` - The node to start searching from.
    `str` - A valid XPath string.
    `namespaceNode` - The node from which prefixes in the XPath will be resolved to namespaces.
  Returns:
    An XObject, which can be used to obtain a string, number, nodelist, etc, should never be null.
  Throws:
    TransformerException -
  See Also:
    `XObject`, `XNull`, `XBoolean`, `XNumber`, `XString`, `XRTreeFrag`

### eval

    public static XObject eval(Node contextNode,
                               java.lang.String str,
                               Node namespaceNode)
                        throws TransformerException

  Evaluate XPath string to an XObject. XPath namespace prefixes are resolved from the namespaceNode. The implementation of this is a little slow, since it creates a number of objects each time it is called. This could be optimized to keep the same objects around, but then thread-safety issues would arise.
  Parameters:
    `contextNode` - The node to start searching from.
    `str` - A valid XPath string.
    `namespaceNode` - The node from which prefixes in the XPath will be resolved to namespaces.
  Returns:
    An XObject, which can be used to obtain a string, number, nodelist, etc, should never be null.
  Throws:
    TransformerException -
  See Also:
    `XObject`, `XNull`, `XBoolean`, `XNumber`, `XString`, `XRTreeFrag`

### eval

    public static XObject eval(Node contextNode,
                               java.lang.String str,
                               PrefixResolver prefixResolver)
                        throws TransformerException

  Evaluate XPath string to an XObject. XPath namespace prefixes are resolved from the namespaceNode. The implementation of this is a little slow, since it creates a number of objects each time it is called. This could be optimized to keep the same objects around, but then thread-safety issues would arise.
  Parameters:
    `contextNode` - The node to start searching from.
    `str` - A valid XPath string.
    `namespaceNode` - The node from which prefixes in the XPath will be resolved to namespaces.
    `prefixResolver` - Will be called if the parser encounters namespace prefixes, to resolve the prefixes to URLs.
  Returns:
    An XObject, which can be used to obtain a string, number, nodelist, etc, should never be null.
  Throws:
    TransformerException -
  See Also:
    `XObject`, `XNull`, `XBoolean`, `XNumber`, `XString`, `XRTreeFrag`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2002 Apache XML Project. All Rights Reserved.